<?php

namespace Drupal\entity_workflow_workspace\Access;

use Drupal\Core\Access\AccessResult;
use Drupal\Core\Routing\Access\AccessInterface;
use Drupal\Core\Routing\RouteMatchInterface;
use Symfony\Component\Routing\Route;

/**
 * Checks whether a workspace state type is either 'open' or 'closed'.
 *
 * Requirements key: '_workspace_state_type'.
 */
class WorkspaceStateTypeAccess implements AccessInterface {

  /**
   * Checks address book access.
   *
   * @return \Drupal\Core\Access\AccessResultInterface
   *   The access result.
   */
  public function access(Route $route, RouteMatchInterface $route_match) {
    $requirement = $route->getRequirement('_workspace_state_type');
    $workspace = $route_match->getParameter('workspace');

    return AccessResult::allowedIf(wse_workspace_get_state_type($workspace) === $requirement);
  }

}
