<?php

namespace Drupal\entity_workflow_workspace\Routing;

use Drupal\Core\Routing\RouteSubscriberBase;
use Symfony\Component\Routing\RouteCollection;

/**
 * Subscriber for entity_workflow_workspace routes.
 *
 * @internal
 *   Tagged services are internal.
 */
class RouteSubscriber extends RouteSubscriberBase {

  /**
   * {@inheritdoc}
   */
  protected function alterRoutes(RouteCollection $collection) {
    // Add the '_workspace_state_type' requirement to the activate workspace
    // route so that users can't switch into closed workspaces.
    if ($route = $collection->get('entity.workspace.activate_form')) {
      $route->addRequirements(['_workspace_state_type' => 'open']);
    }

    // Disallow access the generic 'Publish' route, publication is done through
    // a workflow transition now.
    if ($route = $collection->get('entity.workspace.publish_form')) {
      $route->addRequirements(['_access' => 'FALSE']);
    }
  }

}
